/*
 *  TOPPERS Software
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 *
 *  Copyright (C) 2012 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 *
 *  @(#) $Id: sample1.h 1716 2010-01-31 11:39:18Z ertl-hiro $
 */

#include <kernel.h>
#include <t_syslog.h>
#include <t_stdlib.h>
#include "syssvc/serial.h"
#include "syssvc/syslog.h"
#include "kernel_cfg.h"
#include "perf.h"
#include "histogram.h"
#include "target_timer.h"
#include "test_lib.h"

/*
 *  ӥΥ顼Υ
 */
Inline void
svc_perror(const char *file, int_t line, const char *expr, ER ercd)
{
	if (ercd < 0) {
		t_perror(LOG_ERROR, file, line, expr, ercd);
	}
}

#define	SVC_PERROR(expr)	svc_perror(__FILE__, __LINE__, #expr, (expr))

/*
 *  ư¬ѿ
 */
PERFCNT perf_boot_time[4];

/*
 *  ưַ¬ѽ롼
 */
void
perf_boot_time_inithdr(intptr_t exinf)
{
	x_get_pcc(&perf_boot_time[2]);
	x_rst_pcc();
}

/*
 *  ưַ¬ѥ
 */
void
perf_boot_time_task(intptr_t exinf)
{
	x_get_pcc(&perf_boot_time[3]);
	x_rst_pcc();
}

/*
 *  ¬ȼ¹ԻʬۤϿ
 */
#define NO_MEASURE	10000U			/* ¬ */
#define MAX_TIME	10000U			/* ¹ԻʬۤϿ */

/*
 *  ¹ԻʬۤϿΰ
 */
static uint_t	histarea1[MAX_TIME + 1];
static uint_t	histarea2[MAX_TIME + 1];

/*
 *  act_tsk ǥѥåʤ¬Ѵؿ
 */
void
task_act_tsk_nodsp_low(intptr_t exinf)
{

}

void
task_act_tsk_nodsp_high(intptr_t exinf)
{
	uint_t	i;

	for (i = 0; i < NO_MEASURE; i++) {
		begin_measure(1);
		act_tsk(TASK_ACT_TSK_NODSP_LOW);
		end_measure(1);
		ter_tsk(TASK_ACT_TSK_NODSP_LOW);
	}
	wup_tsk(MAIN_TASK);
}

/*
 *  act_tsk ǥѥå¬Ѵؿ
 */

void
task_act_tsk_dsp_low(intptr_t exinf)
{
	uint_t	i;

	for (i = 0; i < NO_MEASURE; i++) {
		begin_measure(2);
		act_tsk(TASK_ACT_TSK_DSP_HIGH);
		end_measure(2);
	}
	wup_tsk(MAIN_TASK);
}

void
task_act_tsk_dsp_high(intptr_t exinf)
{

}

bool_t start_eval_int;
bool_t end_eval_int;
uint_t eval_int_hist[MAX_TIME + 1];
int    perf_int_latency_count;

/*
 *  ַ߱¬
 */
void
perf_int_latency(void)
{
	uint_t timer_count;
	if (start_eval_int == true) {
		timer_count = target_timer_get_current();
		if (TO_USEC(timer_count) < MAX_TIME){
			eval_int_hist[TO_USEC(timer_count)]++;
		}
		else {
			eval_int_hist[MAX_TIME]++;
		}
		 perf_int_latency_count++;
		if( perf_int_latency_count == NO_MEASURE) {
			perf_int_latency_count = 0;
			start_eval_int = false;
			end_eval_int = true;
			iwup_tsk(MAIN_TASK);
		}
	}
	
}

void
print_perf_int_latency(void)
{
	uint32_t i;
	int out_count = 0;

	for(i = 0; i < (MAX_TIME + 1); i++) {
		if (eval_int_hist[i] != 0) {
			syslog_2(LOG_NOTICE, "%d us, %d", i, eval_int_hist[i]);
			out_count++;
		}
	}
}
/*
 *  ᥤ󥿥
 */
void main_task(intptr_t exinf)
{
	ulong_t t0,t1,t2,t3;
	uint32_t i;

	/*
	 *  BSSνѤʤ礬뤿ᡤǽ
	 */
	for (i = 0; i <= MAX_TIME; i++) {
		histarea1[i] = 0;
		histarea2[i] = 0;
		eval_int_hist[i] =0;
	}

	syslog_1(LOG_NOTICE, "Performance evaluation program start. Please wait about %d sec.", NO_MEASURE/1000);
	syslog_flush();

	/*
	 *  act_tsk ǥѥåʤ¬
	 */
	init_hist(1, MAX_TIME, histarea1);
	act_tsk(TASK_ACT_TSK_NODSP_HIGH);
	slp_tsk();
	ter_tsk(TASK_ACT_TSK_NODSP_HIGH);

	/*
	 *  act_tsk ǥѥå¬
	 */
	init_hist(2, MAX_TIME, histarea2);
	act_tsk(TASK_ACT_TSK_DSP_LOW);
	slp_tsk();
	ter_tsk(TASK_ACT_TSK_DSP_LOW);

	/*
	 *  ֤߱¬
	 */
	perf_int_latency_count = 0;
	start_eval_int = true;
	slp_tsk();

	/*
	 *  ¬̤ν
	 */
	t0 = x_cnv_nsec(perf_boot_time[0]);
	t1 = x_cnv_nsec(perf_boot_time[1]);
	t2 = x_cnv_nsec(perf_boot_time[2]);
	t3 = x_cnv_nsec(perf_boot_time[3]);
	syslog_0(LOG_NOTICE, "Boot time.");
	syslog_1(LOG_NOTICE, "Total time              %ld ns", t0+t1+t2+t3);
	syslog_1(LOG_NOTICE, "Boot to sta_ker         %ld ns", t0);
	syslog_1(LOG_NOTICE, "target init             %ld ns", t1);
	syslog_1(LOG_NOTICE, "OS Obj init to inithdr  %ld ns", t2);
	syslog_1(LOG_NOTICE, "inithdr to inittask     %ld ns", t3);
	syslog_flush();

	syslog_0(LOG_NOTICE, "act_tsk without dispatch[ns].");
	print_hist(1);

	syslog_0(LOG_NOTICE, "act_tsk with dispatch[ns].");
	print_hist(2);

	syslog_0(LOG_NOTICE, "Interrupt Latency.");
	print_perf_int_latency();

	syslog_0(LOG_NOTICE, "Performance measurement end.");
	syslog_flush();

	ext_ker();
	assert(0);
}
